package org.artifactory.security.ldap;

import org.artifactory.api.context.ArtifactoryContextThreadBinder;
import org.artifactory.descriptor.security.ldap.LdapSetting;
import org.artifactory.test.ArtifactoryHomeBoundTest;
import org.testng.annotations.AfterMethod;
import org.testng.annotations.Test;

import static org.testng.Assert.assertEquals;

/**
 * @author BarakH
 */
public class LdapServiceImplTest extends ArtifactoryHomeBoundTest {
    @AfterMethod
    public void afterMethod() {
        ArtifactoryContextThreadBinder.unbind();
    }

    @Test
    public void testGetAccountLockoutDurationCached() {
        LdapServiceTestChild ldapService = new LdapServiceTestChild();
        LdapSetting ldapSetting = new LdapSetting();
        ldapSetting.setLdapUrl("ldap://10.70.30.11/OU=OUL1ID0,OU=RootOU2,dc=jfrog,dc=test,dc=com");

        ldapService.lockoutDurationAttributeValue = 5L;
        assertEquals(Long.valueOf(5), ldapService.getAccountLockoutDuration(ldapSetting));

        ldapService.lockoutDurationAttributeValue = 10L;
        assertEquals(Long.valueOf(5), ldapService.getAccountLockoutDuration(ldapSetting));
    }

    private static class LdapServiceTestChild extends LdapServiceImpl {

        private Long lockoutDurationAttributeValue;

        @Override
        Long loadLockoutDurationAttributeValue(LdapSetting setting) {
            return lockoutDurationAttributeValue;
        }
    }
}