#!/usr/bin/env bash

set -e

PROJECT_ROOT_DIR="$(cd "$(dirname "${BASH_SOURCE[0]}")" && cd ../../.. && pwd)"
BRANCH=""
export PROJECT_ROOT_DIR
# shellcheck disable=SC1090
source "${PROJECT_ROOT_DIR}/build/ci/scripts/lib/pipelineUtils.sh"
source "${PROJECT_ROOT_DIR}/build/ci/scripts/lib/mavenUtils.sh"
# shellcheck disable=SC1090

function on_execute() {
    local branch params repository
    branch="$(pipeline_gitBranchName)"
    repository="$(maven_devArtifactRepoName "${branch}")"
    params="-d LOCAL_BRANCH_NAME=${branch} -d DEV_PROCESS=false -d REPOSITORY=${repository}"
    "${PROJECT_ROOT_DIR}/build/ci/scripts/triggerJenkins.sh" --job=artifactory/test/artifactory-db-unit-testing-facade-multi-select --is-single-branch="true" --params="${params}" --timeout=3600
}
